"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpDispatcherServiceClient = void 0;
const axios_1 = require("./axios");
const logger = require("../../../log");
class HttpDispatcherServiceClient {
    constructor(baseUrl) {
        this.version = '2022-12-01~experimental';
        this.baseUrl = baseUrl;
    }
    async createConnection(params, data) {
        var _a, _b, _c, _d;
        const path = `/hidden/broker/${params.hashedBrokerToken}/connections/${params.brokerClientId}`;
        const response = await axios_1.axiosInstance.post(path, {
            data: {
                attributes: {
                    deployment_location: data.deployment_location,
                },
            },
        }, {
            baseURL: this.baseUrl,
            headers: {
                'Content-type': 'application/vnd.api+json',
            },
            params: { version: this.version },
            validateStatus: () => true,
        });
        const apiResponse = (_a = response === null || response === void 0 ? void 0 : response.data) === null || _a === void 0 ? void 0 : _a.data;
        const snykRequestId = response.headers['snyk-request-id'] || '';
        logger.trace({ snykRequestId, apiResponse }, 'createConnection API response');
        const serverId = ((_d = (_c = (_b = response === null || response === void 0 ? void 0 : response.data) === null || _b === void 0 ? void 0 : _b.data) === null || _c === void 0 ? void 0 : _c.attributes) === null || _d === void 0 ? void 0 : _d.server_id) || '-1';
        return response.status === 201 ? serverId : '-1';
    }
}
exports.HttpDispatcherServiceClient = HttpDispatcherServiceClient;
//# sourceMappingURL=api.js.map